Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.beans
Class Expression

    java.lang.Object
      |
      +--java.beans.Statement
            |
            +--java.beans.Expression

public class Expression
extends Statement

An `Expression` object represents a primitive expression in which a single method is applied to a target and a set of arguments to return a result - as in `"a.getFoo()"`.

In addition to the properties of the super class, the `Expression` object provides a value which is the object returned when this expression is evaluated. The return value is typically not provided by the caller and is instead computed by dynamically finding the method and invoking it when the first call to `getValue` is made.

Since:
  1.4
See Also:
  `getValue()`, `setValue(java.lang.Object)`

Constructor Summary
`Expression(Object value, Object target, String methodName, Object[] arguments)` Creates a new `Expression` object for a method that returns a result.
`Expression(Object target, String methodName, Object[] arguments)` Creates a new `Statement` object with a `target`, `methodName` and `arguments` as per the parameters.

Method Summary
`Object` | `getValue()` If the value property of this instance is not already set, this method dynamically finds the method with the specified methodName on this target with these arguments and calls it.
`void` | `setValue(Object value)` Sets the value of this expression to `value`.
`String` | `toString()` Prints the value of this expression using a Java-style syntax.

Methods inherited from class java.beans.Statement
`execute, getArguments, getMethodName, getTarget`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Expression

    public Expression(Object target,
                      String methodName,
                      Object[] arguments)

  Creates a new `Statement` object with a `target`, `methodName` and `arguments` as per the parameters.

Parameters:
  `target` - The target of this expression.
  `methodName` - The methodName of this expression.
  `arguments` - The arguments of this expression.
See Also:
  `getValue()`

### Expression

    public Expression(Object value,
                      Object target,
                      String methodName,
                      Object[] arguments)

  Creates a new `Expression` object for a method that returns a result. The result will never be calculated however, since this constructor uses the `value` parameter to set the value property by calling the `setValue` method.

Parameters:
  `value` - The value of this expression.
  `target` - The target of this expression.
  `methodName` - The methodName of this expression.
  `arguments` - The arguments of this expression.
See Also:
  `setValue(java.lang.Object)`

Method Detail

### getValue

    public Object getValue()
                    throws Exception

  If the value property of this instance is not already set, this method dynamically finds the method with the specified methodName on this target with these arguments and calls it. The result of the method invocation is first copied into the value property of this expression and then returned as the result of `getValue`. If the value property was already set, either by a call to `setValue` or a previous call to `getValue` then the value property is returned without either looking up or calling the method.

  The value property of an `Expression` is set to a unique private (non-`null`) value by default and this value is used as an internal indication that the method has not yet been called. A return value of `null` replaces this default value in the same way that any other value would, ensuring that expressions are never evaluated more than once.

  See the `excecute`method for details on how methods are chosen using the dynamic types of the target and arguments.``

  Returns:
    The result of applying this method to these arguments.
    `Exception`
  See Also:
    `Statement.execute()`, `setValue(java.lang.Object)`

### setValue

    public void setValue(Object value)

  Sets the value of this expression to `value`. This value will be returned by the getValue method without calling the method associated with this expression.

  Parameters:
    `value` - The value of this expression.
  See Also:
    `getValue()`

### toString

    public String toString()

  Prints the value of this expression using a Java-style syntax.

  Overrides:
    `toString` in class `Statement`
  Returns:
    a string representation of the object.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.